;################################################################################
;#										#
;# libeep - EEPROM R/W library for ATmega controllers				#
;# copyright (c) 2007-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 3		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.if ctype==8
;------------------------------------------------------------------------------
; read one byte (tempreg1) from EEPROM memory (Y+)
;------------------------------------------------------------------------------
libeep_read:	sbic	EECR,EEWE
		rjmp	libeep_read
		out	EEARH,YH
		out	EEARL,YL
		sbi	EECR,EERE
		in	tempreg1,EEDR
		adiw	YL,1
		ret				;thats all

;------------------------------------------------------------------------------
; write one byte (tempreg1) to EEPROM memory (Y+) with verify
;------------------------------------------------------------------------------
libeep_write:	sbic	EECR,EEWE		;wait for EEPROM ready
		rjmp	libeep_write
		out	EEARH,YH
		out	EEARL,YL
		
libeep_write2:	ldi	tempreg2,4		;max tries
libeep_write3:	out	EEDR,tempreg1		;write byte
		cli
		sbi	EECR,EEMWE
		sbi	EECR,EEWE
		sei
libeep_write4:	sbic	EECR,EEWE		;verify
		rjmp	libeep_write4
		adiw	YL,1
		ret
.endif

.if ctype==16
;------------------------------------------------------------------------------
; read one byte (tempreg1) from EEPROM memory (Y+)
;------------------------------------------------------------------------------
libeep_read:	sbic	EECR,EEWE
		rjmp	libeep_read
		out	EEARH,YH
		out	EEARL,YL
		sbi	EECR,EERE
		in	tempreg1,EEDR
		adiw	YL,1
		ret				;thats all

;------------------------------------------------------------------------------
; write one byte (tempreg1) to EEPROM memory (Y+) with verify
;------------------------------------------------------------------------------
libeep_write:	sbic	EECR,EEWE		;wait for EEPROM ready
		rjmp	libeep_write
		out	EEARH,YH
		out	EEARL,YL

libeep_write2:	ldi	tempreg2,4		;max tries
libeep_write3:	out	EEDR,tempreg1		;write byte
		cli
		sbi	EECR,EEMWE
		sbi	EECR,EEWE
		sei
libeep_write4:	sbic	EECR,EEWE		;verify
		rjmp	libeep_write4
		adiw	YL,1
		ret
.endif

.if ctype==88
;------------------------------------------------------------------------------
; read one byte (tempreg1) from EEPROM memory (Y+)
;------------------------------------------------------------------------------
libeep_read:	sbic	EECR,EEPE
		rjmp	libeep_read
		out	EEARH,YH
		out	EEARL,YL
		sbi	EECR,EERE
		in	tempreg1,EEDR
		adiw	YL,1
		ret				;thats all

;------------------------------------------------------------------------------
; write one byte (tempreg1) to EEPROM memory (Y+) with verify
;------------------------------------------------------------------------------
libeep_write:	sbic	EECR,EEPE		;wait for EEPROM ready
		rjmp	libeep_write
		out	EEARH,YH
		out	EEARL,YL

libeep_write2:	ldi	tempreg2,4		;max tries
libeep_write3:	out	EEDR,tempreg1		;write byte
		cli
		sbi	EECR,EEMPE
		sbi	EECR,EEPE
		sei
libeep_write4:	sbic	EECR,EEPE		;verify
		rjmp	libeep_write4
		adiw	YL,1
		ret
.endif


