;################################################################################
;#										#
;# libmio - multi i/o for ATMega 8/16/88					#
;# copyright (c) 2005-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# * B/W videodisplay with up to 30x23 chars					#
;# * 1 channel sound can play notes and noise					#
;# * ps2-keyboard interface							#
;# * 1200 Bps bidirectional serial port						#
;# * pseudorandom generator							#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public				#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;uncomment next line to enable the whole library if avr_libmake is not used
;.set	use_libmio_all	= 1

.def	libmio_cur_x	= r10
.def	libmio_cur_y	= r11

;--------------------------------------------------------------------------------
; screen definition
;--------------------------------------------------------------------------------
.equ	libmio_cols = 30
.equ	libmio_rows = 23
.equ	libmio_pixel_rows = 230

;--------------------------------------------------------------------------------
; ntsc timing
;--------------------------------------------------------------------------------
.if video == ntsc
    .equ	libmio_vstart = 245
    .equ	libmio_vstop = 251
    .equ	libmio_hslen = 64
    .equ	libmio_counter = 1016
    .equ	libmio_maxlines = 7
    .equ	libmio_hstart = 160
.endif

;--------------------------------------------------------------------------------
; pal timing
;--------------------------------------------------------------------------------
.if video == pal
    .equ	libmio_vstart = 12
    .equ	libmio_vstop = 17
    .equ	libmio_hslen = 72
    .equ	libmio_counter = 1023
    .equ	libmio_maxlines = 56
    .equ	libmio_hstart = 160
.endif


;--------------------------------------------------------------------------------
; system RAM offsets
;--------------------------------------------------------------------------------
.equ	libmio_rampos_l	= 0
.equ	libmio_rampos_h = 1
.equ	libmio_vflags	= 2
.equ	libmio_frames	= 3
.equ	libmio_cline	= 4
.equ	libmio_kbdshift	= 5
.equ 	libmio_kbdstate	= 6
.equ	libmio_scancode	= 7
.equ	libmio_keycode	= 8
.equ	libmio_lastkey	= 9

.equ	libmio_rand1	= 10
.equ	libmio_rand2	= 11
.equ	libmio_rand3	= 12
.equ	libmio_rand4	= 13
.equ	libmio_color	= 14
.equ	libmio_kflags	= 15

.equ	libmio_dds_l	= 16
.equ	libmio_dds_h	= 17
.equ	libmio_envval	= 18
.equ	libmio_tone	= 19
.equ	libmio_pwm	= 20
.equ	libmio_tincnt	= 21
.equ	libmio_tintmp	= 22
.equ	libmio_serout	= 23
.equ	libmio_tcnt	= 24
.equ	libmio_tdat	= 25
.equ	libmio_cflag	= 26
.equ	libmio_rcnt	= 27
.equ	libmio_rdat	= 28
.equ	libmio_serin	= 29
.equ	libmio_fastmode = 30
.equ	libmio_sysconf	= 31
.equ	libmio_tbcnt	= 32
.equ	libmio_rbcnt	= 33
