#!/usr/bin/perl
#################################################################################
#										#
# table generator for libmio							#
# copyright (c) 2006-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
#										#
#										#
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 3		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
# General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public			#
# License along with this library; if not, write to the				#
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
# Boston, MA 02111-1307, USA.							#
#										#
#################################################################################

$takt=16000000;
$pwm=256;
$maxcount=65536;
$fakt=3.5;


###############################################################################
# create offset table
###############################################################################
print "Offset offset: $cellno \n";
$sprung=exp(log(2)/12);
$samfrq=$takt/$pwm;

for($x=0;$x<64;$x++)
{
    $freq=220*$sprung**($x+3);
    $delta=$maxcount*$freq/$samfrq;
    $y=int($delta+0.5);
    $yl=$y%256;
    $cell[$cellno]=$yl;	
    $yh=$y/256;
    $cell[$cellno+1]=$yh;
    $cellno+=2;		
}

###############################################################################
# write interleaved table
###############################################################################
open (WTAB, ">../snd.inc");
    for($i=0;$i<8;$i++)
    {
        print WTAB "        .db "; 
        for($j=0;$j<16;$j++)
        {
	    $cellpos=$i*16+$j;
	    $y=$cell[$cellpos];
	    if ($y<1) {printf WTAB "0x00"} 
	    else {printf WTAB "%#2.2x",$y};
	    if ($j<15) {print WTAB ","}
	    else {print WTAB "\n"};
	}
    }
close(WTAB);

