
;-------------------------------------------------------------------------------
; plot  XL=X XH=Y  
;-------------------------------------------------------------------------------
.ifdef use_libmio_plot
libmio_plot:	push_ptr			;save coords
		cpi	XL,libmio_cols*2	;right limit
		brcc	libmio_nplot		;yes
		cpi	XH,libmio_rows*2	;right limit
		brcc	libmio_nplot		;yes

libmio_plot_0:	ldi	ZH,1			;bit left top
		sbrc	XH,0
		lsl	ZH
		sbrc	XH,0
		lsl	ZH
		sbrc	XL,0
		lsl	ZH		;ZH = bitmask
		lsr	XH			;Y/2
		lsr	XL			;X/2
		ldi	YL,libmio_cols		;columns
		mul	XH,YL			;calc Y*libmio_cols
				
		ldi	YH,HIGH(libmio_vram)	;start of chars
		ldi	YL,LOW(libmio_vram)
		add	YL,XL			;add X
		adc	YH,const_0
		add	YL,r0			;add Y*libmio_cols
		adc	YH,r1
		ld	XL,Y			;get char
		andi	XL,0x0f			;only plot
		lds	XH,libmio_ram+libmio_color		;plot color
		sbrs	XH,0			;skip if set
		com	ZH		
		sbrs	XH,0
		and	XL,ZH
		sbrc	XH,0
		or	XL,ZH
		st	Y,XL
libmio_nplot:	pop_ptr

.endif

;-------------------------------------------------------------------------------
; correct plot coordinates from YL,YH to ZL,ZH
;-------------------------------------------------------------------------------
libmio_corrp:	cp	ZL,YL
		brcc	libmio_corrp1
		mov	r0,ZL
		mov	ZL,YL
		mov	YL,r0
libmio_corrp1:	cp	ZH,YH
		brcc	libmio_corrp2
		mov	r0,ZH
		mov	ZH,YH
		mov	YH,r0
libmio_corrp2:	ret

;-------------------------------------------------------------------------------
; box YL,YH to ZL,ZH
;-------------------------------------------------------------------------------
.ifdef use_libmio_box
libmio_box:	push_ptr
		rcall	libmio_corrp
libmio_box_2:	mov	XL,YL
		mov	XH,YH
libmio_box_3:	rcall	libmio_plot
		inc	XL
		cp	XL,ZL
		brne	libmio_box_3
libmio_box_4:	rcall	libmio_plot
		inc	XH
		cp	ZH,XH
		brne	libmio_box_4
libmio_box_5:	rcall	libmio_plot
		dec	XL
		cp	XL,YL
		brne	libmio_box_5
libmio_box_6:	rcall	libmio_plot
		dec	XH
		cp	XH,YH
		brne	libmio_box_6
		pop_ptr
.endif

;-------------------------------------------------------------------------------
; fbox YL,YH to ZL,ZH
;-------------------------------------------------------------------------------
.ifdef use_libmio_fbox
libmio_fbox:	push_ptr
		rcall	libmio_corrp
libmio_fbox_2:	mov	XH,YH
libmio_fbox_3:	mov	XL,YL
libmio_fbox_4:	rcall	libmio_plot
		cp	XL,ZL
		breq	libmio_fbox_5
		inc	XL
		rjmp	libmio_fbox_4
libmio_fbox_5:	rcall	libmio_plot
		cp	ZH,XH
		breq	libmio_fbox_6
		inc	XH
		rjmp	libmio_fbox_3
libmio_fbox_6:	pop_ptr
.endif


;-------------------------------------------------------------------------------
; draw line from YL,YH to ZL,ZH
; this algorithm is a little bit quick and dirty, but it works...
;-------------------------------------------------------------------------------
.ifdef use_libmio_draw
libmio_draw:	push_ptr
		movw	XL,YL			;copy start pointer
		ldi	r16,0xff		;set sgn(dx) negative
		sub	YL,ZL			;x1-x2
		brcc	libmio_draw01		;branch if x1<x2
		neg	r16			;invert sgn(dx)
		neg	YL			;invert dx
libmio_draw01:	ldi	r17,0xff		;set sgn(dy) negative
		sub	YH,ZH			;-dy
		brcc	libmio_draw02		;branch if y1<y2
		neg	r17			;invert sgn(dy)
		neg	YH			;invert dy
libmio_draw02:	cp	YL,YH			;|dx|-|dy|
		brcs	libmio_draw6		;branch if |dy|>|dx|
		rjmp	libmio_draw3

;|dx|>|dy|
libmio_draw3:	mov	r18,YL			;|dx|
		lsr	r18			;/2
libmio_draw4:	rcall	libmio_plot		;plot pixel
		cp	XL,ZL			;the endpoint?
		breq	libmio_draw_e		;yes
		add	XL,r16			;X-step
		sub	r18,YH			;-|dy|
		brcc	libmio_draw4		;no overflow
		add	XH,r17			;y-step
		add	r18,YL
		rjmp	libmio_draw4

;|dy|>|dx|
libmio_draw6:	mov	r18,YH			;|dy|
		lsr	r18			;/2
libmio_draw7:	rcall	libmio_plot		;plot pixel
		cp	XH,ZH			;the endpoint?
		breq	libmio_draw_e
		add	XH,r17			;y-step
		sub	r18,YL
		brcc	libmio_draw7			
		add	XL,r16			;x-step
		add	r18,YH
		rjmp	libmio_draw7

libmio_draw_e:	pop_ptr
.endif

