;################################################################################
;#										#
;# keyboard table (german layout)						#
;# copyright (c) 2006-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 3		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;-------------------------------------------------------------------------------
; scancode tables
; f0-fc function keys
; e0=pos1 e1=end e2=left e3=right e4=up e5=down e6=pgup e7=pgdown e8=ins e9=del
; ea=enter eb=tab ec=backspace ed=esc 
;-------------------------------------------------------------------------------

libmio_ktab1:	.db 0x00,0xf9,0x00,0xf5,0xf3,0xf1,0xf2,0xfc	;scancode 00-07
		.db 0x00,0xfa,0xf8,0xf6,0xf4,0xeb,0x5e,0x00	;scancode 08-0f
		.db 0xf7,0x00,0x00,0x00,0x00, 'q', '1',0x00	;scancode 10-17
		.db 0x00,0x00, 'y', 's', 'a', 'w', '2',0x00	;scancode 18-1f
		.db 0x00, 'c', 'x', 'd', 'e', '4', '3',0x00	;scancode 20-27
		.db 0x00,0x20, 'v', 'f', 't', 'r', '5',0x00	;scancode 28-2f
		.db 0x00, 'n', 'b', 'h', 'g', 'z', '6',0x00	;scancode 30-37
		.db 0x00,0x00, 'm', 'j', 'u', '7', '8',0x00	;scancode 38-3f
		.db 0x00,0x2c, 'k', 'i', 'o', '0', '9',0x00	;scancode 40-47
		.db 0x00,0x2e,0x2d, 'l',0x00, 'p',0x00,0x00	;scancode 48-4f
		.db 0x00,0x00,0x00,0x00,0x00,0x27,0x00,0x00	;scancode 50-57
		.db 0x00,0x00,0xea, '+',0x00, '#',0x00,0x00	;scancode 58-5f
		.db 0x00, '<',0x00,0x00,0x00,0x00,0xec,0x00	;scancode 60-67
		.db 0x00, '1',0x00, '4', '7',0x00,0x00,0x00	;scancode 68-6f
		.db  '0',0x2c, '2', '5', '6', '8',0xed,0x00	;scancode 70-77
		.db 0xfb,0x2b, '3', '-', '*', '9',0x00,0x00	;scancode 78-7f

		.db 0x00,0xf9,0x00,0xf5,0xf3,0xf1,0xf2,0xfc	;scancode 00-07
		.db 0x00,0xfa,0xf8,0xf6,0xf4,0xeb,0x00,0x00	;scancode 08-0f
		.db 0xf7,0x00,0x00,0x00,0x00, 'Q', '!',0x00	;scancode 10-17
		.db 0x00,0x00, 'Y', 'S', 'A', 'W',0x22,0x00	;scancode 18-1f
		.db 0x00, 'C', 'X', 'D', 'E', '$', '@',0x00	;scancode 20-27
		.db 0x00,0x20, 'V', 'F', 'T', 'R', '%',0x00	;scancode 28-2f
		.db 0x00, 'N', 'B', 'H', 'G', 'Z', '&',0x00	;scancode 30-37
		.db 0x00,0x00, 'M', 'J', 'U', '/', '(',0x00	;scancode 38-3f
		.db 0x00,0x3b, 'K', 'I', 'O', '=', ')',0x00	;scancode 40-47
		.db 0x00,0x3a,0x5f, 'L',0x00, 'P', '?',0x00	;scancode 48-4f
		.db 0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x00	;scancode 50-57
		.db 0x00,0x00,0xea, '*',0x00,0x27,0x00,0x00	;scancode 58-5f
		.db 0x00, '>',0x00,0x00,0x00,0x00,0xec,0x00	;scancode 60-67
		.db 0x00, '1',0x00, '4', '7',0x00,0x00,0x00	;scancode 68-6f
		.db  '0',0xe9, '2', '5', '6', '8',0xed,0x00	;scancode 70-77
		.db 0xfb,0x2b, '3', '-', '*', '9',0x00,0x00	;scancode 78-7f

libmio_ktab2:	.db 0x00,0xe1,0x00,0xe2,0xe0,0x00,0x00,0x00	;scancode 68-6f
		.db 0xe8,0xe9,0xe5,0x00,0xe3,0xe4,0xed,0x00	;scancode 70-77
		.db 0xfb,0x2b,0xe7, '-', '*',0xe6,0x00,0x00	;scancode 78-7f
