;################################################################################
;#										#
;# libmio - multi i/o for ATMega 8 						#
;# copyright (c) 2005-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public				#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libmio_vint
    jmp		libmio_isr
.endm

.macro libmio_init
    call	libmio_init
.endm

.macro libmio_outchar
    call	libmio_char
.endm

.macro libmio_outspace
    call	libmio_space
.endm

.macro libmio_waitkey
    .set	use_libmio_waitkey = 1
    .set	libmio_ps2key = 1
    call	libmio_waitkey
.endm

.macro libmio_nokey
    .set	use_libmio_waitnokey = 1
    .set	libmio_ps2key = 1
    call	libmio_wnokey
.endm

.macro libmio_cursor
    .set	use_libmio_cursor = 1
    .set	libmio_ps2key = 1
    call	libmio_cursor
.endm

.macro libmio_freecur
    .set	use_libmio_cursor = 1
    .set	libmio_ps2key = 1
    call	libmio_cur1
.endm

.macro libmio_outdez
    .set	use_libmio_outd = 1
    call	libmio_outd
.endm

.macro libmio_clrscr
    call	libmio_clr
.endm

.macro libmio_fillchar
    call	libmio_fill
.endm

.macro libmio_ramtext
    .set	use_libmio_oram = 1
    call	libmio_oram
.endm

.macro libmio_input
    .set	use_libmio_input = 1
    call	libmio_inp
.endm

.macro libmio_romtext
    .set	use_libmio_orom = 1
    call	libmio_orom
.endm

.macro libmio_thistext
    .set	use_libmio_othis = 1
    .set	use_libmio_gotoxy = 1
    call	libmio_othis
.endm

.macro libmio_thisinvtext
    .set	use_libmio_othis = 1
    .set	use_libmio_gotoxy = 1
    call	libmio_othisi
.endm

.macro libmio_mtext
    .set	use_libmio_mtext = 1
    call	libmio_mtext
.endm

.macro libmio_newline
    .set	use_libmio_newline = 1
    call	libmio_newline
.endm

.macro libmio_gotoxy
    .set	use_libmio_gotoxy = 1
    call	libmio_gxy
.endm

.macro libmio_plot
    .set	use_libmio_plot = 1
    call	libmio_plot
.endm

.macro libmio_box
    .set	use_libmio_plot = 1
    .set	use_libmio_box = 1
    call	libmio_box
.endm

.macro libmio_cbox
    .set	use_libmio_cbox = 1
    call	libmio_cbox
.endm

.macro libmio_ibox
    .set	use_libmio_ibox = 1
    call	libmio_ibox
.endm

.macro libmio_wbox
    .set	use_libmio_wbox = 1
    call	libmio_wbox
.endm

.macro libmio_whbox
    .set	use_libmio_wbox = 1
    .set	use_libmio_whbox = 1
    call	libmio_whbox
.endm

.macro libmio_wh2box
    .set	use_libmio_wbox = 1
    .set	use_libmio_whbox = 1
    call	libmio_wh2box
.endm

.macro libmio_fbox
    .set	use_libmio_plot = 1
    .set	use_libmio_fbox = 1
    call	libmio_fbox
.endm

.macro libmio_draw
    .set	use_libmio_plot = 1
    .set	use_libmio_draw = 1
    call	libmio_draw
.endm

.macro libmio_sync
    .set	use_libmio_sync = 1
    call	libmio_sync
.endm

.macro libmio_wms
    .set	use_libmio_wms = 1
    call	libmio_wms
.endm

.macro libmio_note
    .set	use_libmio_note = 1
    call	libmio_note
.endm

.macro libmio_calc
    call	libmio_calc
.endm

.macro libmio_ecalc
    call	libmio_ecalc
.endm

.macro libmio_setcolor
    call	libmio_setcol
.endm

.macro libmio_setnormal
    call	libmio_setnorm
.endm

.macro libmio_setinvers
    call	libmio_setinv
.endm

.macro libmio_calc
    call	libmio_calc
.endm

.macro libmio_vcur
    .set	use_libmio_vcur = 1
    call	libmio_vcur
.endm

.macro libmio_random
    .set	use_libmio_psrg = 1
    call	libmio_psrg
.endm

.macro libmio_scroll
    call	libmio_scrl
.endm

.macro libmio_getser
    call	libmio_gser
.endm

.macro libmio_putser
    call	libmio_pser
.endm

.macro libmio_sernl
    call	libmio_snl
.endm

.macro libmio_screenshot
    call	libmio_scrs
.endm

