;################################################################################
;#										#
;# video generation code 23x30 monochrome					#
;# copyright (c) 2006-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 3		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;-------------------------------------------------------------------------------
; -output character line 4 clocks per pixel
; -128 characters are in table 6x8px each
;-------------------------------------------------------------------------------
libmio_isv_01:	ldd	ZL,Y+libmio_cline	;line number
		bst	ZL,0
		lsr	ZL
		andi	ZL,0x07
		ldi	ZH,HIGH(libmio_ctable*2)
		add	ZH,ZL
		ld	XL,Y			;2 BS low
		ldd	XH,Y+libmio_rampos_h	;1 BS high

		ld	ZL,X+			;2 get next char
		mov	YL,ZL			;1 copy char
		bld	ZL,7			;1 replace bit 7
		lpm	r0,Z			;3
		sbrc	YL,7			;1 skip if no invert
		com	r0			;1 invert next pixline
		ldi	YH,30			;number of chars

;---------------------------------------------------------------------4
libmio_isv_02:	out	vport,r0		;1 out pix 1
		lsl	r0			;1 prepare pix2
		ld	ZL,X+			;2 get next char
;---------------------------------------------------------------------4
		out	vport,r0		;1 out pix 2
		lsl	r0			;1 prepare pix3
		mov	YL,ZL			;1 copy char
		bld	ZL,7			;1 replace bit 7
;---------------------------------------------------------------------4
		out	vport,r0		;1 out pix 3
		lsl	r0			;1 prepare pix4
		mov	r1,r0			;1 copy
		lsl	r1			;1 prepare pix 5
;---------------------------------------------------------------------4
		out	vport,r0		;1 out pix 4
		lpm	r0,Z			;3 get next pixline
;---------------------------------------------------------------------4
		out	vport,r1		;1 out pix 5
		lsl	r1			;1 prepare pix 6
		sbrc	YL,7			;1 skip if no invert
		com	r0			;1 invert next pixline
;---------------------------------------------------------------------4
		out	vport,r1		;1 out pix 6
		dec	YH			;1 counter
		brne	libmio_isv_02		;2
;---------------------------------------------------------------------
		nop				;1 filling cycle
		out	vport,const_0		;1 set to black
		ld	ZL,-X			;2 correct X-register
		
		ldi	YL,LOW(libmio_ram)	;1 set ptr again
		ldi	YH,HIGH(libmio_ram)
		ldd	ZH,Y+libmio_cline	;line number
		inc	ZH
		std	Y+libmio_cline,ZH
		cpi	ZH,10
		brne	libmio_isv_03
		rcall	libmio_stx1
libmio_isv_03:
libmio_is_15:
