;#######6#########################################################################
;#										#
;# chipbasic - single chip basic computer with ATMega 8/16/88			#
;# full screen editor								#
;# copyright (c) 2006-9 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 3		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.set	editor_linestart = 2
.set	editor_linedigits = 2
.set	bas_linelen = 27

;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
editor_main:	libmio_setnormal		;set color
		libmio_clrscr			;clear screen
		libmio_nokey
		ldi	YL,0
		ldi	YH,3
		ldi	ZL,libmio_cols*2-1
		ldi	ZH,libmio_rows*2-2
		libmio_box
;write line numbers
editor_lnum:	ldi	XH,2			;Y start
editor_lnum_1:	ldi	XL,1			;X
		libmio_gotoxy
		mov	XL,XH
		dec	XL
		rcall	editor_odez
		inc	XH
		cpi	XH,0x16
		brne	editor_lnum_1
		rcall	editor_stat		;show status line
		rcall	editor_bottom
		
editor_main_n:	set				;load mode
		call	mem_load		;get text
editor_main_r:	ldi	XL,4			;cursor pos to home
		ldi	XH,2
editor_main_0:	mov	libmio_cur_x,XL
		mov	libmio_cur_y,XH
editor_main_1:	libmio_cursor
				
;------------------------------------------------------------------------------
;cursor left key
;------------------------------------------------------------------------------
editor_main_3:	cpi	tempreg1,0xe2		;left
		brne	editor_main_4
		dec	XL
		rjmp	editor_checkb

;------------------------------------------------------------------------------
;cursor right key
;------------------------------------------------------------------------------
editor_main_4:	cpi	tempreg1,0xe3		;right
		brne	editor_main_5
		inc	XL	
		rjmp	editor_checkb

;------------------------------------------------------------------------------
;cursor up key
;------------------------------------------------------------------------------
editor_main_5:	cpi	tempreg1,0xe4		;up
		brne	editor_main_6
		dec	XH
		rjmp	editor_checkb

;------------------------------------------------------------------------------
;cursor down key
;------------------------------------------------------------------------------
editor_main_6:	cpi	tempreg1,0xe5		;down
		brne	editor_main_7
		inc	XH
		rjmp	editor_checkb

;------------------------------------------------------------------------------
;enter key
;------------------------------------------------------------------------------
editor_main_7:	cpi	tempreg1,0xea		;enter
		brne	editor_main_70
		inc	XH
		ldi	XL,2
		rjmp	editor_checkb

;------------------------------------------------------------------------------
;limit coordinates to editable area
;------------------------------------------------------------------------------
editor_checkb:	cpi	XL,4
		brcc	editor_chb1
		ldi	XL,4

editor_chb1:	cpi	XL,libmio_cols-1
		brcs	editor_chb2
		ldi	XL,libmio_cols-2
					
editor_chb2:	cpi	XH,2
		brcc	editor_chb3
		ldi	XH,2
		
editor_chb3:	cpi	XH,2+bas_lines
		brcs	editor_chb4
		ldi	XH,2+bas_lines-1
		
editor_chb4:	rjmp	editor_main_0			

;------------------------------------------------------------------------------
;alt+delete key
;------------------------------------------------------------------------------
editor_main_70:	lds	tempreg2,libmio_ram+libmio_kbdstate
		sbrs	tempreg2,4
		rjmp	editor_main_8
		cpi	tempreg1,0xe9		;delete
		brne	editor_chb4		;main loop
		ldi	XL,4			;start of line
		mov	libmio_cur_x,XL
		libmio_calc			;set Y
		ldi	tempreg1,0x20		;space
		ldi	tempreg2,libmio_cols-5
editor_main_71:	st	Y+,tempreg1
		dec	tempreg2
		brne	editor_main_71		
		rjmp	editor_main_0

;------------------------------------------------------------------------------
;delete key
;------------------------------------------------------------------------------
editor_main_8:	cpi	tempreg1,0xe9		;delete
		brne	editor_main_9
		rcall	editor_dchar
		rjmp	editor_main_1

;------------------------------------------------------------------------------
;backspace key
;------------------------------------------------------------------------------
editor_main_9:	cpi	tempreg1,0xec		;backspace
		brne	editor_main_a
		mov	XL,libmio_cur_x		;actual cursor
		cpi	XL,4			;at the beginning?
		brne	editor_main_91		;no
		rjmp	editor_main_1		;loop
editor_main_91:	dec	XL
		mov	libmio_cur_x,XL
		rcall	editor_dchar
		rjmp	editor_main_1		;loop

;------------------------------------------------------------------------------
;F2 Name
;------------------------------------------------------------------------------
editor_main_a:	cpi	tempreg1,0xf2		;F2 key (Name)
		brne	editor_main_c		;no
		push	libmio_cur_x		;save cursor coords 
		push	libmio_cur_y
		ldi	XL,11			;coords of filename
		ldi	XH,0
		ldi	tempreg1,12		;12 chars
		libmio_input

editor_name_e:	pop	libmio_cur_y		;restore cursor coords
		pop	libmio_cur_x
		call	mem_save
		rjmp	editor_main

;------------------------------------------------------------------------------
;F3 File
;------------------------------------------------------------------------------
editor_main_c:	cpi	tempreg1,0xf3
		brne	editor_main_d
		rcall	file_main
		mov	XH,tempreg4
		cpi	XH,0x08
		brcc	editor_fs_1
		rcall	editor_load
		rjmp	editor_main_r
editor_fs_1:	cpi	XH,0x10
		brcc	editor_fs_2
		rcall	editor_csl
		libmio_thisinvtext
		.db	1,2,"Save",0,0
		mov	XH,tempreg4
		andi	XH,0x03
		rcall	editor_save
editor_fs_2:	rjmp	editor_main

;------------------------------------------------------------------------------
;F1 reload/load
;------------------------------------------------------------------------------
editor_main_d:	cpi	tempreg1,0xf1
		brne	editor_mainr
		lds	tempreg2,libmio_ram+libmio_kbdstate
		sbrs	tempreg2,2
		rjmp	editor_main_re
		libmio_thisinvtext
		.db	1,2,"Read from Serial",0,0
		rcall	editor_recv
		rcall	editor_stat		;show status line (redraw)
		rjmp	editor_main_r
			
editor_main_re:	call	mem_load
		clr	ereg
		rjmp	editor_main		;restart with new program

;------------------------------------------------------------------------------
;F4 run
;------------------------------------------------------------------------------
editor_mainr:	cpi	tempreg1,0xf4
		brne	editor_main_sa
		rcall	editor_ptx		;save prog
		rcall	editor_run
		rjmp	editor_main

editor_run:	libmio_setnormal
		libmio_clrscr
		call	runprog
		sts	libmio_ram+libmio_fastmode,const_0	;enable video
		libmio_thisinvtext
		.db	22,0,"Press ESC!",0,0
editor_run_1:	libmio_nokey
		libmio_waitkey		
		cpi 	tempreg1,0xed		;ESC
		brne	editor_run_1	
		ret

;------------------------------------------------------------------------------
;F11 send
;------------------------------------------------------------------------------
editor_main_sa:	cpi	tempreg1,0xfb
		brne	editor_char
		rcall	editor_ptx		;save prog
		rcall	editor_send
		rjmp	editor_main

;------------------------------------------------------------------------------
;a visible  char
;------------------------------------------------------------------------------
editor_char:	lds	XL,libmio_ram+libmio_kbdstate
		sbrc	XL,2			;left ctrl
		rjmp	editor_main_ig		;ignore
		sbrc	XL,3			;right ctrl
		rjmp	editor_main_ig		;ignore
		cpi	tempreg1,0x80		;last+1
		brcc	editor_main_ig		;ignore
		mov	XL,libmio_cur_x		;cursor position x
		cpi	XL,libmio_cols-2	;at the end?
		breq	editor_main_28
		mov	tempreg2,XL		;save x-pos
		ldi	XL,libmio_cols-2
		mov	libmio_cur_x,XL
		libmio_calc
editor_main_21:	ld	XH,-Y			;char on cursor pos
		std	Y+1,XH			;write to next
		dec	XL
		cp	XL,tempreg2
		brne	editor_main_21
		mov	libmio_cur_x,XL
		libmio_calc
		st	Y,tempreg1
		inc	XL
		mov	libmio_cur_x,XL
		libmio_calc
editor_main_ig:	rjmp	editor_main_1

editor_main_28:	libmio_calc			;calculate vram address
		st	Y,tempreg1
		rjmp	editor_main_1		;loop


;------------------------------------------------------------------------------
;del char on cursor pos
;------------------------------------------------------------------------------
editor_dchar:	libmio_calc
		mov	XL,libmio_cur_x		;cursor position x
editor_dchar_1:	cpi	XL,libmio_cols-2	;at the end?
		breq	editor_dchar_2
		ldd	XH,Y+1
		st	Y+,XH
		inc	XL
		rjmp	editor_dchar_1

editor_dchar_2:	ldi	XH,0x20			;space
		st	Y,XH
		ret

;------------------------------------------------------------------------------
;save program to flash
;------------------------------------------------------------------------------
editor_ptx:	clt
		call	mem_load
		brts	editor_ptx_01
		ret

editor_ptx_01:	call	mem_save
		ret

;------------------------------------------------------------------------------
;set status line 
;------------------------------------------------------------------------------
editor_stat:	rcall	editor_csl
;set status line
		andi	ereg,0x07		;limit errors
		ldi	XH,1
		ldi 	XL,2
		libmio_setinvers
		libmio_gotoxy
		ldi	ZL,LOW(editor_errtab*2)	;error text table
		ldi	ZH,HIGH(editor_errtab*2)
editor_stat_03:	cpi	ereg,0x00		;zero?
		breq	editor_stat_05		;yes->print
editor_stat_04:	lpm	tempreg1,Z+		;skip text
		cpi	tempreg1,0x00
		brne	editor_stat_04
		dec	ereg			;errnum -1
		rjmp	editor_stat_03

editor_stat_05:	libmio_romtext
		libmio_thistext
		.db	255," in ",0
		mov	XL,bas_line
		inc	XL
		rcall	editor_odez
		ldi	tempreg1,':'
		libmio_outchar
		mov	tempreg1,bas_statement
		subi	tempreg1,0xcf
		libmio_outchar
		ret

editor_csl:	ldi	XL,0xa0				;space invers
		ldi	ZL,LOW(libmio_vram+libmio_cols)
		ldi	ZH,HIGH(libmio_vram+libmio_cols)
		ldi	XH,libmio_cols
editor_csl_01:	st	Z+,XL
		dec	XH
		brne	editor_csl_01
		ret
;------------------------------------------------------------------------------
;output dez number 1-12 (XL) to Y+
;------------------------------------------------------------------------------
editor_odez:	push	tempreg1
		push	XL
		set
		jmp	libmio_outd_10

;------------------------------------------------------------------------------
;set bottom line 
;------------------------------------------------------------------------------
editor_bottom:	libmio_thisinvtext
		.db	22,2," Load ",0x0c," Name ",0x0c," Disk ",0x0c," Run ",0,0

		libmio_setnormal
		libmio_thistext
		.db	0,2,"Program: ",0
		jmp	mem_load_5		;redraw program name

;------------------------------------------------------------------------------
;get text from eeprom
;------------------------------------------------------------------------------
editor_load:	rcall	editor_sca		;set code address
editor_load_1:	ldi	tempreg1,25		;number of chars
editor_load_2:	rcall	editor_loadb		;get char
		st	Y+,tempreg2		;store char
		dec	tempreg1
		brne	editor_load_2
		adiw	YL,5			;skip line number
		dec	tempreg4
		brne	editor_load_1
		rcall	editor_sna		;set name address
editor_load_3:	rcall	editor_loadb		;get char
		st	Y+,tempreg2		;store char
		dec	tempreg4
		brne	editor_load_3
		ret

editor_loadb:	libi2c_read			;get EEPROM char
		libmio_wms
		ret

;------------------------------------------------------------------------------
;get text from serial
;------------------------------------------------------------------------------
editor_recv:	libmio_getser			;wait for start of name
		cpi	tempreg2,':'
		brne	editor_recv
editor_recv_2:	rcall	editor_sna		;set name address
		ldi	tempreg4,12		;name len
		rcall	editor_readl

editor_recv_4:	ldi	YL,LOW(libmio_vram+(libmio_cols*2)+1)	;start prog
		ldi	YH,HIGH(libmio_vram+(libmio_cols*2)+1)
		ldi	r18,20			;number of lines
editor_recv_5:	ldi	tempreg4,28		;max chars
		rcall	editor_readl		;read line
		adiw	YL,30
		dec	r18
		brne	editor_recv_5
		ret

;clear and read line
editor_readl:	movw	ZL,YL
		mov	r16,tempreg4
		ldi	r17,0x20
editor_readl_1:	st	Z+,r17
		dec	r16
		brne	editor_readl_1
		movw	ZL,YL
editor_readl_2:	libmio_getser
		cpi	tempreg2,0x20		;visible
		brcs	editor_readl_2
		rjmp	editor_readl_4
editor_readl_3:	libmio_getser
editor_readl_4:	cpi	tempreg2,0x20		;visible
		brcs	editor_readl_e		;end?
		st	Z+,tempreg2
		dec	tempreg4
		brne	editor_readl_3
;ignore additional chars
editor_readl_5:	libmio_getser
		cpi	tempreg2,0x20		;visible
		brcc	editor_readl_5
editor_readl_e:	ret

;------------------------------------------------------------------------------
; write program to eeprom
;------------------------------------------------------------------------------
editor_save:	rcall	editor_sca		;set code address
editor_save_01:	ldi	tempreg1,25		;chars per line
editor_save_02:	ld	tempreg2,Y+
		rcall	editor_saveb
		dec	tempreg1
		brne	editor_save_02
		adiw	YL,5
		dec	tempreg4
		brne	editor_save_01
		rcall	editor_sna		;set name address
editor_save_03:	ld	tempreg2,Y+
		rcall	editor_saveb
		dec	tempreg4
		brne	editor_save_03
		ret

editor_saveb:	libi2c_write
		ldi	tempreg3,20
editor_saveb1:	libmio_wms
		dec	tempreg3
		brne	editor_saveb1
		ret

;------------------------------------------------------------------------------
; send program
;------------------------------------------------------------------------------
editor_send:	ldi	ZL,LOW(editor_sendh*2)	;start of header
		ldi	ZH,HIGH(editor_sendh*2)
editor_send_1:	lpm	tempreg2,Z+
		libmio_putser
		cpi	tempreg2,':'
		brne	editor_send_1

		rcall	editor_sna		;set code address
		ldi	tempreg4,12		;name len
editor_send_2:	ld	tempreg2,Y+
		libmio_putser
		dec	tempreg4
		brne	editor_send_2
		libmio_sernl
		ldi	YL,LOW(libmio_vram+(libmio_cols*2)+1)
		ldi	YH,HIGH(libmio_vram+(libmio_cols*2)+1)
		ldi	tempreg4,20		;number of lines
editor_send_5:	ldi	tempreg1,28		;chars per line
editor_send_6:	ld	tempreg2,Y+		;get char
		libmio_putser			;out
		dec	tempreg1
		brne	editor_send_6
		adiw	YL,2			;skip frame
		libmio_sernl			;newline
		dec	tempreg4
		brne	editor_send_5
		ret

editor_sendh:	.db 	"PRG:"
;------------------------------------------------------------------------------
;set code address
;------------------------------------------------------------------------------
editor_sca:	andi	XH,0x03
		lsl	XH
		clr	XL
		ldi	YL,LOW(libmio_vram+(libmio_cols*2)+4)
		ldi	YH,HIGH(libmio_vram+(libmio_cols*2)+4)
		ldi	tempreg4,20		;number of lines
		ret

;------------------------------------------------------------------------------
;set name address
;------------------------------------------------------------------------------
editor_sna:	ldi	YL,LOW(libmio_vram+11)
		ldi	YH,HIGH(libmio_vram+11)
		ldi	tempreg4,12		;name len
		ret

;------------------------------------------------------------------------------
;status messages
;------------------------------------------------------------------------------
editor_errtab:	.db "END",0,"Break",0,"Syn Err",0,"Expr Err",0,"Stack Err",0,0
