;################################################################################
;#										#
;# chipbasic - single chip basic computer with ATMega 8/16/88			#
;# intro screen									#
;# copyright (c) 2006-2009 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 3		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
intro_main:	libmio_setnormal		;set color
		libmio_clrscr			;clear screen
		libmio_thistext
		.db	22,2," (c)2006-9 Joerg Wolfram ",0

		ldi	YL,3
		ldi	YH,6
		ldi	ZL,54
		ldi	ZH,19
		libmio_fbox

		libmio_thistext
		.db	2,2,0,0
		rcall	intro_pins
		libmio_thistext
		.db	10,2,0,0
		rcall	intro_pins

		libmio_thisinvtext
.if ctype == mega8
		.db	5,8,"AVR-ChipBasic8",0,0
.endif
.if ctype == mega16
		.db	5,6,"AVR-ChipBasic8-16",0
.endif
.if ctype == mega88
		.db	5,6,"AVR-ChipBasic8-88",0
.endif

		libmio_thisinvtext
		.db	6,8,"V0.50-ATM18",0

		libmio_thisinvtext
		.db	7,6,"Elektor & CCZwei",0,0


		ldi	tempreg3,150		;wait about 3 seconds
intro_main_w:	libmio_sync
		libmio_screenshot
		dec	tempreg3
		brne	intro_main_w
		ret

intro_pins:	ldi	tempreg3,13
intro_pins_1:	libmio_thistext
		.db	255,0x10,0x20,0
		dec	tempreg3
		brne	intro_pins_1
		ret
